diff --git a/src/gui/kernel/qguiapplication.cpp b/src/gui/kernel/qguiapplication.cpp
index e5657000cf..b67a2e66a5 100644
--- a/src/gui/kernel/qguiapplication.cpp
+++ b/src/gui/kernel/qguiapplication.cpp
@@ -2029,6 +2029,7 @@ void QGuiApplicationPrivate::processMouseEvent(QWindowSystemInterfacePrivate::Mo
     modifier_buttons = e->modifiers;
     QPointF localPoint = e->localPos;
     QPointF globalPoint = e->globalPos;
+
     bool doubleClick = false;
 
     if (mouseMove) {
@@ -2084,6 +2085,8 @@ void QGuiApplicationPrivate::processMouseEvent(QWindowSystemInterfacePrivate::Mo
             }
     }
 #endif
+    if (type== QEvent::MouseButtonPress)
+        qDebug() << __FUNCTION__ <<  window << "loc=" <<  localPoint << "glob=" << globalPoint;
 
     QMouseEvent ev(type, localPoint, localPoint, globalPoint, button, e->buttons, e->modifiers, e->source);
     ev.setTimestamp(e->timestamp);
diff --git a/src/gui/kernel/qwindowsysteminterface.cpp b/src/gui/kernel/qwindowsysteminterface.cpp
index 67e1283462..9c391ed45f 100644
--- a/src/gui/kernel/qwindowsysteminterface.cpp
+++ b/src/gui/kernel/qwindowsysteminterface.cpp
@@ -396,6 +396,9 @@ QT_DEFINE_QPA_EVENT_HANDLER(void, handleMouseEvent, QWindow *window, ulong times
 {
     auto localPos = QHighDpi::fromNativeLocalPosition(local, window);
     auto globalPos = QHighDpi::fromNativePixels(global, window);
+    if (type == QEvent::MouseButtonPress)
+        qDebug() << __FUNCTION__ <<    window  << "native local=" << local << "global=" << global
+         << "qt: " << localPos << globalPos;
 
     QWindowSystemInterfacePrivate::MouseEvent *e =
         new QWindowSystemInterfacePrivate::MouseEvent(window, timestamp, localPos, globalPos,
diff --git a/src/widgets/kernel/qwidgetwindow.cpp b/src/widgets/kernel/qwidgetwindow.cpp
index 7292c795b8..2909d6d284 100644
--- a/src/widgets/kernel/qwidgetwindow.cpp
+++ b/src/widgets/kernel/qwidgetwindow.cpp
@@ -487,6 +487,8 @@ void QWidgetWindow::handleNonClientAreaMouseEvent(QMouseEvent *e)
 
 void QWidgetWindow::handleMouseEvent(QMouseEvent *event)
 {
+    if (event->type() == QEvent::MouseButtonPress)
+        qDebug() << __FUNCTION__ << this << "click" << event->pos() << event->globalPos();
     static const QEvent::Type contextMenuTrigger =
         QGuiApplicationPrivate::platformTheme()->themeHint(QPlatformTheme::ContextMenuOnMouseRelease).toBool() ?
         QEvent::MouseButtonRelease : QEvent::MouseButtonPress;
@@ -615,6 +617,7 @@ void QWidgetWindow::handleMouseEvent(QMouseEvent *event)
                 receiver = qt_button_down;
             else if(popupChild)
                 receiver = popupChild;
+            qDebug() << __FUNCTION__ << "create ctx #1" << this << event->globalPos();
             QContextMenuEvent e(QContextMenuEvent::Mouse, mapped, event->globalPos(), event->modifiers());
             QApplication::forwardEvent(receiver, &e, event);
         }
@@ -665,6 +668,7 @@ void QWidgetWindow::handleMouseEvent(QMouseEvent *event)
 #ifndef QT_NO_CONTEXTMENU
     if (event->type() == contextMenuTrigger && event->button() == Qt::RightButton
         && m_widget->rect().contains(event->pos())) {
+qDebug() << __FUNCTION__ << this << "creating  ctx #2 gp" << event->globalPos();
         QContextMenuEvent e(QContextMenuEvent::Mouse, mapped, event->globalPos(), event->modifiers());
         QGuiApplication::forwardEvent(receiver, &e, event);
     }
diff --git a/src/widgets/widgets/qplaintextedit.cpp b/src/widgets/widgets/qplaintextedit.cpp
index d6f6a364a8..4cd0181df4 100644
--- a/src/widgets/widgets/qplaintextedit.cpp
+++ b/src/widgets/widgets/qplaintextedit.cpp
@@ -1552,6 +1552,7 @@ bool QPlainTextEdit::event(QEvent *e)
         && static_cast<QContextMenuEvent *>(e)->reason() == QContextMenuEvent::Keyboard) {
         ensureCursorVisible();
         const QPoint cursorPos = cursorRect().center();
+        qDebug() << __FUNCTION__ << cursorPos << d->viewport->mapToGlobal(cursorPos);
         QContextMenuEvent ce(QContextMenuEvent::Keyboard, cursorPos, d->viewport->mapToGlobal(cursorPos));
         ce.setAccepted(e->isAccepted());
         const bool result = QAbstractScrollArea::event(&ce);