diff --git a/src/plugins/platforms/windows/qwindowscursor.cpp b/src/plugins/platforms/windows/qwindowscursor.cpp
index 00d011ccec..f3937ed165 100644
--- a/src/plugins/platforms/windows/qwindowscursor.cpp
+++ b/src/plugins/platforms/windows/qwindowscursor.cpp
@@ -627,8 +627,10 @@ void QWindowsCursor::changeCursor(QCursor *cursorIn, QWindow *window)
 // window borders. Enforce the cursor again (to be called from enter event).
 void QWindowsCursor::enforceOverrideCursor()
 {
-    if (hasOverrideCursor() && m_overrideCursor != GetCursor())
+    if (hasOverrideCursor() && m_overrideCursor != GetCursor()) {
+        qDebug() << __FUNCTION__ << "set over";
         SetCursor(m_overrideCursor);
+    }
 }
 
 void QWindowsCursor::setOverrideCursor(const QCursor &cursor)
@@ -636,6 +638,7 @@ void QWindowsCursor::setOverrideCursor(const QCursor &cursor)
     const CursorHandlePtr wcursor = cursorHandle(cursor);
     if (const auto overrideCursor = wcursor->handle()) {
         m_overrideCursor = overrideCursor;
+        qDebug() << __FUNCTION__ << "set over";
         const HCURSOR previousCursor = SetCursor(overrideCursor);
         if (m_overriddenCursor == nullptr)
             m_overriddenCursor = previousCursor;
@@ -648,6 +651,7 @@ void QWindowsCursor::setOverrideCursor(const QCursor &cursor)
 void QWindowsCursor::clearOverrideCursor()
 {
     if (m_overriddenCursor) {
+        qDebug() << __FUNCTION__ ;
         SetCursor(m_overriddenCursor);
         m_overriddenCursor = m_overrideCursor = nullptr;
     }
diff --git a/src/plugins/platforms/windows/qwindowsmousehandler.cpp b/src/plugins/platforms/windows/qwindowsmousehandler.cpp
index 737fd1d2a9..7c1846673a 100644
--- a/src/plugins/platforms/windows/qwindowsmousehandler.cpp
+++ b/src/plugins/platforms/windows/qwindowsmousehandler.cpp
@@ -440,6 +440,14 @@ bool QWindowsMouseHandler::translateMouseEvent(QWindow *window, HWND hwnd,
         // 1) There is no capture and we move to a new window.
         // 2) There is capture and we move into the capturing window.
         // 3) The capture just ended and we are over non-capturing window.
+        {
+            auto dbg = qDebug() ;
+            dbg << __FUNCTION__ ;
+            if (m_windowUnderMouse)
+                  dbg << "m_winUnderM=" << m_windowUnderMouse->objectName();
+            if (currentWindowUnderMouse)
+                dbg << "currentWinUnderM=" << currentWindowUnderMouse->objectName();
+        }
         if ((currentWindowUnderMouse && m_windowUnderMouse != currentWindowUnderMouse
                 && (!hasCapture || currentWindowUnderMouse == window))
             || (m_previousCaptureWindow && window != m_previousCaptureWindow && currentWindowUnderMouse
diff --git a/src/plugins/platforms/windows/qwindowspointerhandler.cpp b/src/plugins/platforms/windows/qwindowspointerhandler.cpp
index f1960f1585..6af5182d5b 100644
--- a/src/plugins/platforms/windows/qwindowspointerhandler.cpp
+++ b/src/plugins/platforms/windows/qwindowspointerhandler.cpp
@@ -372,6 +372,14 @@ void QWindowsPointerHandler::handleEnterLeave(QWindow *window,
         //    Note: Leaving the application entirely is handled in translateMouseEvent(WM_MOUSELEAVE).
         // 2) There is capture and we move out of the capturing window.
         // 3) There is a new capture and we were over another window.
+        {
+            auto dbg = qDebug() ;
+            dbg << __FUNCTION__ ;
+            if (m_windowUnderPointer)
+                  dbg << "m_winUnderP=" << m_windowUnderPointer->objectName();
+            if (currentWindowUnderPointer)
+                dbg << "currentWinUnderP=" << currentWindowUnderPointer->objectName();
+        }
         if ((m_windowUnderPointer && m_windowUnderPointer != currentWindowUnderPointer
                 && (!hasCapture || window == m_windowUnderPointer))
             || (hasCapture && m_previousCaptureWindow != window && m_windowUnderPointer
diff --git a/src/plugins/platforms/windows/qwindowswindow.cpp b/src/plugins/platforms/windows/qwindowswindow.cpp
index 99be4882bb..4d79768c4a 100644
--- a/src/plugins/platforms/windows/qwindowswindow.cpp
+++ b/src/plugins/platforms/windows/qwindowswindow.cpp
@@ -2557,6 +2557,7 @@ static inline bool applyNewCursor(const QWindow *w)
 
 void QWindowsWindow::applyCursor()
 {
+    qDebug() << "APPLYCURSOR" << window()->objectName() << "has o" << QWindowsCursor::hasOverrideCursor();
     if (QWindowsCursor::hasOverrideCursor()) {
         if (isTopLevel())
             QWindowsCursor::enforceOverrideCursor();