diff --git a/sources/shiboken2/tests/libother/CMakeLists.txt b/sources/shiboken2/tests/libother/CMakeLists.txt
index 6aba91e1..77e5c8e2 100644
--- a/sources/shiboken2/tests/libother/CMakeLists.txt
+++ b/sources/shiboken2/tests/libother/CMakeLists.txt
@@ -10,7 +10,7 @@ othermultiplederived.cpp
 add_library(libother SHARED ${libother_SRC})
 target_include_directories(libother PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
 target_compile_definitions(libother PRIVATE LIBOTHER_BUILD)
-target_link_libraries(libother PUBLIC libsample)
+target_link_libraries(libother PUBLIC libsample libsmart)
 set_property(TARGET libother PROPERTY PREFIX "")
 
 
diff --git a/sources/shiboken2/tests/libother/otherobjecttype.cpp b/sources/shiboken2/tests/libother/otherobjecttype.cpp
index ca356ce9..361fb0ca 100644
--- a/sources/shiboken2/tests/libother/otherobjecttype.cpp
+++ b/sources/shiboken2/tests/libother/otherobjecttype.cpp
@@ -28,6 +28,11 @@
 
 #include "otherobjecttype.h"
 
+void OtherObjectType::foo(const SharedPtr<Integer>&)
+{
+
+}
+
 Collector&
 operator<<(Collector& collector, const OtherObjectType& obj)
 {
diff --git a/sources/shiboken2/tests/libother/otherobjecttype.h b/sources/shiboken2/tests/libother/otherobjecttype.h
index 22687c8b..692cafca 100644
--- a/sources/shiboken2/tests/libother/otherobjecttype.h
+++ b/sources/shiboken2/tests/libother/otherobjecttype.h
@@ -30,16 +30,18 @@
 #define OTHEROBJECTTYPE_H
 
 #include <list>
+#include <smart.h>
+
 #include "str.h"
 
 #include "libothermacros.h"
 #include "objecttype.h"
 #include "collector.h"
 
-class OtherObjectType : public ObjectType
+class LIBOTHER_API OtherObjectType : public ObjectType
 {
 public:
-
+    void foo(const SharedPtr<Integer>&);
 };
 
 
diff --git a/sources/shiboken2/tests/otherbinding/CMakeLists.txt b/sources/shiboken2/tests/otherbinding/CMakeLists.txt
index bc5c4bda..d16cdc47 100644
--- a/sources/shiboken2/tests/otherbinding/CMakeLists.txt
+++ b/sources/shiboken2/tests/otherbinding/CMakeLists.txt
@@ -28,8 +28,9 @@ COMMENT "Running generator for 'other' test binding..."
 
 add_library(other MODULE ${other_SRC})
 target_include_directories(other PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}
-                                         ${sample_BINARY_DIR}/sample)
-target_link_libraries(other PUBLIC libother libsample libshiboken)
+                                         ${sample_BINARY_DIR}/sample
+                                         ${smart_BINARY_DIR}/smart)
+target_link_libraries(other PUBLIC libother libsample libsmart libshiboken)
 set_property(TARGET other PROPERTY PREFIX "")
 set_property(TARGET other PROPERTY OUTPUT_NAME "other${PYTHON_EXTENSION_SUFFIX}")
 
@@ -38,6 +39,6 @@ if(WIN32)
 endif()
 
 
-add_dependencies(other sample)
+add_dependencies(other sample smart)
 create_generator_target(other)
 
diff --git a/sources/shiboken2/tests/otherbinding/other-binding.txt.in b/sources/shiboken2/tests/otherbinding/other-binding.txt.in
index a17b70fc..dbe935a9 100644
--- a/sources/shiboken2/tests/otherbinding/other-binding.txt.in
+++ b/sources/shiboken2/tests/otherbinding/other-binding.txt.in
@@ -8,11 +8,13 @@ typesystem-file = @other_TYPESYSTEM@
 output-directory = @CMAKE_CURRENT_BINARY_DIR@
 
 include-path = @libother_SOURCE_DIR@
+include-path = @libsmart_SOURCE_DIR@
 include-path = @libsample_SOURCE_DIR@
 include-path = @libsample_SOURCE_DIR@/..
 
 typesystem-path = @CMAKE_CURRENT_SOURCE_DIR@
 typesystem-path = @sample_SOURCE_DIR@
+typesystem-path = @smart_SOURCE_DIR@
 
 enable-parent-ctor-heuristic
 
diff --git a/sources/shiboken2/tests/otherbinding/typesystem_other.xml b/sources/shiboken2/tests/otherbinding/typesystem_other.xml
index 2932dafb..2fb5c92b 100644
--- a/sources/shiboken2/tests/otherbinding/typesystem_other.xml
+++ b/sources/shiboken2/tests/otherbinding/typesystem_other.xml
@@ -1,6 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <typesystem package="other">
     <load-typesystem name="typesystem_sample.xml" generate="no" />
+    <load-typesystem name="typesystem_smart.xml" generate="no" />
 
     <object-type name="OtherObjectType" />
     <object-type name="OtherDerived" />