diff --git a/src/plugins/platforms/windows/qwindowscontext.cpp b/src/plugins/platforms/windows/qwindowscontext.cpp
index 38b9823d6b..bf869bdbda 100644
--- a/src/plugins/platforms/windows/qwindowscontext.cpp
+++ b/src/plugins/platforms/windows/qwindowscontext.cpp
@@ -1125,11 +1125,13 @@ bool QWindowsContext::windowsProc(HWND hwnd, UINT message,
         return false;
 #endif
     case QtWindows::DisplayChangedEvent:
+        qDebug() << __FUNCTION__ << "DisplayChangedEvent";
         if (QWindowsTheme *t = QWindowsTheme::instance())
             t->displayChanged();
         QWindowsWindow::displayChanged();
         return d->m_screenManager.handleDisplayChange(wParam, lParam);
     case QtWindows::SettingChangedEvent:
+        qDebug() << __FUNCTION__ << "SettingChangedEvent";
         QWindowsWindow::settingsChanged();
         return d->m_screenManager.handleScreenChanges();
     default:
@@ -1332,6 +1334,7 @@ bool QWindowsContext::windowsProc(HWND hwnd, UINT message,
 #endif
     }   break;
     case QtWindows::DpiChangedEvent: {
+        qDebug() << __FUNCTION__ << ">DpiChangedEvent" << platformWindow->window();
         // Try to apply the suggested size first and then notify ScreenChanged
         // so that the resize event sent from QGuiApplication incorporates it
         // WM_DPICHANGED is sent with a size that avoids resize loops (by
@@ -1349,6 +1352,7 @@ bool QWindowsContext::windowsProc(HWND hwnd, UINT message,
             platformWindow->clearFlag(QWindowsWindow::WithinDpiChanged);
         }
         platformWindow->checkForScreenChanged(QWindowsWindow::FromDpiChange);
+        qDebug() << __FUNCTION__ << "<DpiChangedEvent rets" << doResize;
         return doResize;
     }
 #if QT_CONFIG(sessionmanager)
diff --git a/src/plugins/platforms/windows/qwindowsscreen.cpp b/src/plugins/platforms/windows/qwindowsscreen.cpp
index 4137a4bd9a..69d212fd2b 100644
--- a/src/plugins/platforms/windows/qwindowsscreen.cpp
+++ b/src/plugins/platforms/windows/qwindowsscreen.cpp
@@ -294,6 +294,7 @@ QList<QPlatformScreen *> QWindowsScreen::virtualSiblings() const
 
 void QWindowsScreen::handleChanges(const QWindowsScreenData &newData)
 {
+    qDebug() << __FUNCTION__ << newData;
     m_data.physicalSizeMM = newData.physicalSizeMM;
 
     if (m_data.hMonitor != newData.hMonitor) {
@@ -544,6 +545,7 @@ void QWindowsScreenManager::removeScreen(int index)
 
 bool QWindowsScreenManager::handleScreenChanges()
 {
+    qDebug() << __FUNCTION__ << '>';
     // Look for changed monitors, add new ones
     const WindowsScreenDataList newDataList = monitorData();
     const bool lockScreen = newDataList.size() == 1 && (newDataList.front().flags & QWindowsScreenData::LockScreen);
@@ -567,6 +569,7 @@ bool QWindowsScreenManager::handleScreenChanges()
                 removeScreen(i);
         }     // for existing screens
     }     // not lock screen
+    qDebug() << __FUNCTION__ << '<';
     return true;
 }
 
diff --git a/src/plugins/platforms/windows/qwindowswindow.cpp b/src/plugins/platforms/windows/qwindowswindow.cpp
index 7d511bf0d7..3f1614a6ff 100644
--- a/src/plugins/platforms/windows/qwindowswindow.cpp
+++ b/src/plugins/platforms/windows/qwindowswindow.cpp
@@ -1870,20 +1870,25 @@ static inline bool equalDpi(const QDpi &d1, const QDpi &d2)
 
 void QWindowsWindow::checkForScreenChanged(ScreenChangeMode mode)
 {
-    if (parent() || QWindowsScreenManager::isSingleScreen())
+    qDebug() << __FUNCTION__ << mode;
+    if (parent() || QWindowsScreenManager::isSingleScreen()) {
+        qDebug() << __FUNCTION__ << "bailout";
         return;
+    }
 
     QPlatformScreen *currentScreen = screen();
     const QWindowsScreen *newScreen =
         QWindowsContext::instance()->screenManager().screenForHwnd(m_data.hwnd);
-    if (newScreen == nullptr || newScreen == currentScreen)
+    bool nc = newScreen == nullptr || newScreen == currentScreen;
+    qDebug() << __FUNCTION__ << !nc;
+    if (nc)
         return;
     // For screens with different DPI: postpone until WM_DPICHANGE
     if (mode == FromGeometryChange
         && !equalDpi(currentScreen->logicalDpi(), newScreen->logicalDpi())) {
         return;
     }
-    qCDebug(lcQpaWindows).noquote().nospace() << __FUNCTION__
+    qDebug().noquote().nospace() << __FUNCTION__
         << ' ' << window() << " \"" << currentScreen->name()
         << "\"->\"" << newScreen->name() << '"';
     if (mode == FromGeometryChange)
@@ -1896,6 +1901,8 @@ void QWindowsWindow::handleGeometryChange()
 {
     const QRect previousGeometry = m_data.geometry;
     m_data.geometry = geometry_sys();
+    qDebug() << __FUNCTION__ << previousGeometry <<  m_data.geometry
+             <<  "WithinDpiChanged=" << testFlag(WithinDpiChanged);
     if (testFlag(WithinDpiChanged))
         return;  // QGuiApplication will send resize
     QWindowSystemInterface::handleGeometryChange(window(), m_data.geometry);