 ********* Start testing of tst_QTimeZone *********
 Config: Using QtTest library 5.14.0, Qt 5.14.0 (x86_64-little_endian-lp64 shared (dynamic) release build; by GCC 8.3.0)
 PASS   : tst_QTimeZone::initTestCase()
@@ -10,171 +10,171 @@
      0.53 msecs per iteration (total: 69, iterations: 128)
 PASS   : tst_QTimeZone::systemTimeZone()
 RESULT : tst_QTimeZone::systemTimeZone():
-     0.024 msecs per iteration (total: 51, iterations: 2048)
+     0.0036 msecs per iteration (total: 59, iterations: 16384)
 PASS   : tst_QTimeZone::zoneByName(UTC)
 RESULT : tst_QTimeZone::zoneByName():"UTC":
      0.00015 msecs per iteration (total: 82, iterations: 524288)
 PASS   : tst_QTimeZone::zoneByName(Europe/Oslo)
 RESULT : tst_QTimeZone::zoneByName():"Europe/Oslo":
-     0.021 msecs per iteration (total: 89, iterations: 4096)
+     0.0012 msecs per iteration (total: 85, iterations: 65536)
 PASS   : tst_QTimeZone::zoneByName(America/Vancouver)
 RESULT : tst_QTimeZone::zoneByName():"America/Vancouver":
-     0.025 msecs per iteration (total: 52, iterations: 2048)
+     0.0012 msecs per iteration (total: 84, iterations: 65536)
 PASS   : tst_QTimeZone::zoneByName(Europe/Berlin)
 RESULT : tst_QTimeZone::zoneByName():"Europe/Berlin":
-     0.023 msecs per iteration (total: 95, iterations: 4096)
+     0.0012 msecs per iteration (total: 84, iterations: 65536)
 PASS   : tst_QTimeZone::zoneByName(America/Sao_Paulo)
 RESULT : tst_QTimeZone::zoneByName():"America/Sao_Paulo":
-     0.020 msecs per iteration (total: 82, iterations: 4096)
+     0.0012 msecs per iteration (total: 84, iterations: 65536)
 PASS   : tst_QTimeZone::zoneByName(Pacific/Auckland)
 RESULT : tst_QTimeZone::zoneByName():"Pacific/Auckland":
-     0.023 msecs per iteration (total: 97, iterations: 4096)
+     0.0012 msecs per iteration (total: 83, iterations: 65536)
 PASS   : tst_QTimeZone::zoneByName(Australia/Eucla)
 RESULT : tst_QTimeZone::zoneByName():"Australia/Eucla":
-     0.011 msecs per iteration (total: 92, iterations: 8192)
+     0.0012 msecs per iteration (total: 84, iterations: 65536)
 PASS   : tst_QTimeZone::zoneByName(Asia/Kathmandu)
 RESULT : tst_QTimeZone::zoneByName():"Asia/Kathmandu":
-     0.0093 msecs per iteration (total: 77, iterations: 8192)
+     0.0012 msecs per iteration (total: 83, iterations: 65536)
 PASS   : tst_QTimeZone::zoneByName(Pacific/Kiritimati)
 RESULT : tst_QTimeZone::zoneByName():"Pacific/Kiritimati":
-     0.010 msecs per iteration (total: 82, iterations: 8192)
+     0.0012 msecs per iteration (total: 84, iterations: 65536)
 PASS   : tst_QTimeZone::zoneByName(Pacific/Apia)
 RESULT : tst_QTimeZone::zoneByName():"Pacific/Apia":
-     0.016 msecs per iteration (total: 67, iterations: 4096)
+     0.0012 msecs per iteration (total: 85, iterations: 65536)
 PASS   : tst_QTimeZone::zoneByName(UTC+12:00)
 RESULT : tst_QTimeZone::zoneByName():"UTC+12:00":
-     0.0013 msecs per iteration (total: 90, iterations: 65536)
+     0.0013 msecs per iteration (total: 89, iterations: 65536)
 PASS   : tst_QTimeZone::zoneByName(Australia/Sydney)
 RESULT : tst_QTimeZone::zoneByName():"Australia/Sydney":
-     0.021 msecs per iteration (total: 90, iterations: 4096)
+     0.0012 msecs per iteration (total: 84, iterations: 65536)
 PASS   : tst_QTimeZone::zoneByName(Asia/Singapore)
 RESULT : tst_QTimeZone::zoneByName():"Asia/Singapore":
-     0.012 msecs per iteration (total: 53, iterations: 4096)
+     0.0012 msecs per iteration (total: 83, iterations: 65536)
 PASS   : tst_QTimeZone::zoneByName(Australia/Brisbane)
 RESULT : tst_QTimeZone::zoneByName():"Australia/Brisbane":
-     0.010 msecs per iteration (total: 89, iterations: 8192)
+     0.0012 msecs per iteration (total: 84, iterations: 65536)
 PASS   : tst_QTimeZone::zoneByName(Vulcan/ShiKahr)
 RESULT : tst_QTimeZone::zoneByName():"Vulcan/ShiKahr":
-     0.0042 msecs per iteration (total: 69, iterations: 16384)
+     0.0011 msecs per iteration (total: 76, iterations: 65536)
 PASS   : tst_QTimeZone::transitionList(system)
 RESULT : tst_QTimeZone::transitionList():"system":
-     0.020 msecs per iteration (total: 84, iterations: 4096)
+     0.043 msecs per iteration (total: 90, iterations: 2048)
 PASS   : tst_QTimeZone::transitionList(Europe/Oslo)
 RESULT : tst_QTimeZone::transitionList():"Europe/Oslo":
-     0.020 msecs per iteration (total: 85, iterations: 4096)
+     0.045 msecs per iteration (total: 94, iterations: 2048)
 PASS   : tst_QTimeZone::transitionList(America/Vancouver)
 RESULT : tst_QTimeZone::transitionList():"America/Vancouver":
-     0.027 msecs per iteration (total: 56, iterations: 2048)
+     0.062 msecs per iteration (total: 64, iterations: 1024)
 PASS   : tst_QTimeZone::transitionList(Europe/Berlin)
 RESULT : tst_QTimeZone::transitionList():"Europe/Berlin":
-     0.020 msecs per iteration (total: 86, iterations: 4096)
+     0.044 msecs per iteration (total: 91, iterations: 2048)
 PASS   : tst_QTimeZone::transitionList(America/Sao_Paulo)
 RESULT : tst_QTimeZone::transitionList():"America/Sao_Paulo":
-     0.017 msecs per iteration (total: 71, iterations: 4096)
+     0.038 msecs per iteration (total: 78, iterations: 2048)
 PASS   : tst_QTimeZone::transitionList(Pacific/Auckland)
 RESULT : tst_QTimeZone::transitionList():"Pacific/Auckland":
-     0.022 msecs per iteration (total: 93, iterations: 4096)
+     0.049 msecs per iteration (total: 51, iterations: 1024)
 PASS   : tst_QTimeZone::transitionList(Australia/Eucla)
 RESULT : tst_QTimeZone::transitionList():"Australia/Eucla":
-     0.0023 msecs per iteration (total: 78, iterations: 32768)
+     0.0043 msecs per iteration (total: 72, iterations: 16384)
 PASS   : tst_QTimeZone::transitionList(Asia/Kathmandu)
 RESULT : tst_QTimeZone::transitionList():"Asia/Kathmandu":
-     0.00041 msecs per iteration (total: 54, iterations: 131072)
+     0.00079 msecs per iteration (total: 52, iterations: 65536)
 PASS   : tst_QTimeZone::transitionList(Pacific/Kiritimati)
 RESULT : tst_QTimeZone::transitionList():"Pacific/Kiritimati":
-     0.00052 msecs per iteration (total: 69, iterations: 131072)
+     0.00097 msecs per iteration (total: 64, iterations: 65536)
 PASS   : tst_QTimeZone::transitionList(Pacific/Apia)
 RESULT : tst_QTimeZone::transitionList():"Pacific/Apia":
-     0.0074 msecs per iteration (total: 61, iterations: 8192)
+     0.013 msecs per iteration (total: 56, iterations: 4096)
 PASS   : tst_QTimeZone::transitionList(Australia/Sydney)
 RESULT : tst_QTimeZone::transitionList():"Australia/Sydney":
-     0.020 msecs per iteration (total: 82, iterations: 4096)
+     0.045 msecs per iteration (total: 93, iterations: 2048)
 PASS   : tst_QTimeZone::transitionList(Asia/Singapore)
 RESULT : tst_QTimeZone::transitionList():"Asia/Singapore":
-     0.0011 msecs per iteration (total: 73, iterations: 65536)
+     0.0021 msecs per iteration (total: 71, iterations: 32768)
 PASS   : tst_QTimeZone::transitionList(Australia/Brisbane)
 RESULT : tst_QTimeZone::transitionList():"Australia/Brisbane":
-     0.0020 msecs per iteration (total: 67, iterations: 32768)
+     0.0038 msecs per iteration (total: 63, iterations: 16384)
 PASS   : tst_QTimeZone::transitionsForward(system)
 RESULT : tst_QTimeZone::transitionsForward():"system":
-     0.014 msecs per iteration (total: 59, iterations: 4096)
+     0.035 msecs per iteration (total: 73, iterations: 2048)
 PASS   : tst_QTimeZone::transitionsForward(Europe/Oslo)
 RESULT : tst_QTimeZone::transitionsForward():"Europe/Oslo":
-     0.014 msecs per iteration (total: 59, iterations: 4096)
+     0.035 msecs per iteration (total: 73, iterations: 2048)
 PASS   : tst_QTimeZone::transitionsForward(America/Vancouver)
 RESULT : tst_QTimeZone::transitionsForward():"America/Vancouver":
-     0.019 msecs per iteration (total: 78, iterations: 4096)
+     0.057 msecs per iteration (total: 59, iterations: 1024)
 PASS   : tst_QTimeZone::transitionsForward(Europe/Berlin)
 RESULT : tst_QTimeZone::transitionsForward():"Europe/Berlin":
-     0.014 msecs per iteration (total: 60, iterations: 4096)
+     0.036 msecs per iteration (total: 75, iterations: 2048)
 PASS   : tst_QTimeZone::transitionsForward(America/Sao_Paulo)
 RESULT : tst_QTimeZone::transitionsForward():"America/Sao_Paulo":
-     0.013 msecs per iteration (total: 54, iterations: 4096)
+     0.032 msecs per iteration (total: 66, iterations: 2048)
 PASS   : tst_QTimeZone::transitionsForward(Pacific/Auckland)
 RESULT : tst_QTimeZone::transitionsForward():"Pacific/Auckland":
-     0.015 msecs per iteration (total: 64, iterations: 4096)
+     0.041 msecs per iteration (total: 86, iterations: 2048)
 PASS   : tst_QTimeZone::transitionsForward(Australia/Eucla)
 RESULT : tst_QTimeZone::transitionsForward():"Australia/Eucla":
-     0.0020 msecs per iteration (total: 66, iterations: 32768)
+     0.0039 msecs per iteration (total: 64, iterations: 16384)
 PASS   : tst_QTimeZone::transitionsForward(Asia/Kathmandu)
 RESULT : tst_QTimeZone::transitionsForward():"Asia/Kathmandu":
-     0.00027 msecs per iteration (total: 73, iterations: 262144)
+     0.00067 msecs per iteration (total: 89, iterations: 131072)
 PASS   : tst_QTimeZone::transitionsForward(Pacific/Kiritimati)
 RESULT : tst_QTimeZone::transitionsForward():"Pacific/Kiritimati":
-     0.00036 msecs per iteration (total: 96, iterations: 262144)
+     0.00083 msecs per iteration (total: 55, iterations: 65536)
 PASS   : tst_QTimeZone::transitionsForward(Pacific/Apia)
 RESULT : tst_QTimeZone::transitionsForward():"Pacific/Apia":
-     0.0060 msecs per iteration (total: 99, iterations: 16384)
+     0.011 msecs per iteration (total: 96, iterations: 8192)
 PASS   : tst_QTimeZone::transitionsForward(Australia/Sydney)
 RESULT : tst_QTimeZone::transitionsForward():"Australia/Sydney":
-     0.014 msecs per iteration (total: 59, iterations: 4096)
+     0.037 msecs per iteration (total: 77, iterations: 2048)
 PASS   : tst_QTimeZone::transitionsForward(Asia/Singapore)
 RESULT : tst_QTimeZone::transitionsForward():"Asia/Singapore":
-     0.00082 msecs per iteration (total: 54, iterations: 65536)
+     0.0018 msecs per iteration (total: 59, iterations: 32768)
 PASS   : tst_QTimeZone::transitionsForward(Australia/Brisbane)
 RESULT : tst_QTimeZone::transitionsForward():"Australia/Brisbane":
-     0.0016 msecs per iteration (total: 55, iterations: 32768)
+     0.0032 msecs per iteration (total: 54, iterations: 16384)
 PASS   : tst_QTimeZone::transitionsReverse(system)
 RESULT : tst_QTimeZone::transitionsReverse():"system":
-     0.022 msecs per iteration (total: 91, iterations: 4096)
+     0.042 msecs per iteration (total: 87, iterations: 2048)
 PASS   : tst_QTimeZone::transitionsReverse(Europe/Oslo)
 RESULT : tst_QTimeZone::transitionsReverse():"Europe/Oslo":
-     0.022 msecs per iteration (total: 91, iterations: 4096)
+     0.042 msecs per iteration (total: 87, iterations: 2048)
 PASS   : tst_QTimeZone::transitionsReverse(America/Vancouver)
 RESULT : tst_QTimeZone::transitionsReverse():"America/Vancouver":
-     0.026 msecs per iteration (total: 54, iterations: 2048)
+     0.063 msecs per iteration (total: 65, iterations: 1024)
 PASS   : tst_QTimeZone::transitionsReverse(Europe/Berlin)
 RESULT : tst_QTimeZone::transitionsReverse():"Europe/Berlin":
-     0.022 msecs per iteration (total: 93, iterations: 4096)
+     0.043 msecs per iteration (total: 89, iterations: 2048)
 PASS   : tst_QTimeZone::transitionsReverse(America/Sao_Paulo)
 RESULT : tst_QTimeZone::transitionsReverse():"America/Sao_Paulo":
-     0.013 msecs per iteration (total: 54, iterations: 4096)
+     0.031 msecs per iteration (total: 65, iterations: 2048)
 PASS   : tst_QTimeZone::transitionsReverse(Pacific/Auckland)
 RESULT : tst_QTimeZone::transitionsReverse():"Pacific/Auckland":
-     0.023 msecs per iteration (total: 95, iterations: 4096)
+     0.047 msecs per iteration (total: 98, iterations: 2048)
 PASS   : tst_QTimeZone::transitionsReverse(Australia/Eucla)
 RESULT : tst_QTimeZone::transitionsReverse():"Australia/Eucla":
-     0.0019 msecs per iteration (total: 65, iterations: 32768)
+     0.0037 msecs per iteration (total: 62, iterations: 16384)
 PASS   : tst_QTimeZone::transitionsReverse(Asia/Kathmandu)
 RESULT : tst_QTimeZone::transitionsReverse():"Asia/Kathmandu":
-     0.00029 msecs per iteration (total: 77, iterations: 262144)
+     0.00067 msecs per iteration (total: 88, iterations: 131072)
 PASS   : tst_QTimeZone::transitionsReverse(Pacific/Kiritimati)
 RESULT : tst_QTimeZone::transitionsReverse():"Pacific/Kiritimati":
-     0.000381 msecs per iteration (total: 100, iterations: 262144)
+     0.00083 msecs per iteration (total: 55, iterations: 65536)
 PASS   : tst_QTimeZone::transitionsReverse(Pacific/Apia)
 RESULT : tst_QTimeZone::transitionsReverse():"Pacific/Apia":
-     0.00610 msecs per iteration (total: 100, iterations: 16384)
+     0.011 msecs per iteration (total: 93, iterations: 8192)
 PASS   : tst_QTimeZone::transitionsReverse(Australia/Sydney)
 RESULT : tst_QTimeZone::transitionsReverse():"Australia/Sydney":
-     0.021 msecs per iteration (total: 89, iterations: 4096)
+     0.043 msecs per iteration (total: 90, iterations: 2048)
 PASS   : tst_QTimeZone::transitionsReverse(Asia/Singapore)
 RESULT : tst_QTimeZone::transitionsReverse():"Asia/Singapore":
-     0.00083 msecs per iteration (total: 55, iterations: 65536)
+     0.0017 msecs per iteration (total: 58, iterations: 32768)
 PASS   : tst_QTimeZone::transitionsReverse(Australia/Brisbane)
 RESULT : tst_QTimeZone::transitionsReverse():"Australia/Brisbane":
-     0.0020 msecs per iteration (total: 66, iterations: 32768)
+     0.0036 msecs per iteration (total: 59, iterations: 16384)
 PASS   : tst_QTimeZone::cleanupTestCase()
-Totals: 58 passed, 0 failed, 0 skipped, 0 blacklisted, 16973ms
+Totals: 58 passed, 0 failed, 0 skipped, 0 blacklisted, 17117ms
 ********* Finished testing of tst_QTimeZone *********