diff --git a/src/gui/kernel/qshortcutmap.cpp b/src/gui/kernel/qshortcutmap.cpp
index 9ed450b031..b83bebef5f 100644
--- a/src/gui/kernel/qshortcutmap.cpp
+++ b/src/gui/kernel/qshortcutmap.cpp
@@ -165,7 +165,7 @@ int QShortcutMap::addShortcut(QObject *owner, const QKeySequence &key, Qt::Short
     QShortcutEntry newEntry(owner, key, context, --(d->currentId), true, matcher);
     const auto it = std::upper_bound(d->sequences.begin(), d->sequences.end(), newEntry);
     d->sequences.insert(it, newEntry); // Insert sorted
-    qCDebug(lcShortcutMap).nospace()
+    qDebug().nospace()
         << "QShortcutMap::addShortcut(" << owner << ", "
         << key << ", " << context << ") = " << d->currentId;
     return d->currentId;
@@ -182,6 +182,7 @@ int QShortcutMap::addShortcut(QObject *owner, const QKeySequence &key, Qt::Short
 
 int QShortcutMap::removeShortcut(int id, QObject *owner, const QKeySequence &key)
 {
+    qDebug() << __FUNCTION__ << id << owner;
     Q_D(QShortcutMap);
     int itemsRemoved = 0;
     bool allOwners = (owner == 0);
@@ -246,7 +247,7 @@ int QShortcutMap::setShortcutEnabled(bool enable, int id, QObject *owner, const
             return itemsChanged;
         --i;
     }
-    qCDebug(lcShortcutMap).nospace()
+    qDebug().nospace()
         << "QShortcutMap::setShortcutEnabled(" << enable << ", " << id << ", "
         << owner << ", " << key << ") = " << itemsChanged;
     return itemsChanged;
@@ -359,6 +360,7 @@ bool QShortcutMap::tryShortcut(QKeyEvent *e)
 QKeySequence::SequenceMatch QShortcutMap::nextState(QKeyEvent *e)
 {
     Q_D(QShortcutMap);
+    qDebug() << __FUNCTION__ << e;
     // Modifiers can NOT be shortcuts...
     if (e->key() >= Qt::Key_Shift &&
         e->key() <= Qt::Key_Alt)
@@ -426,7 +428,7 @@ QKeySequence::SequenceMatch QShortcutMap::find(QKeyEvent *e, int ignoredModifier
         return QKeySequence::NoMatch;
 
     createNewSequences(e, d->newEntries, ignoredModifiers);
-    qCDebug(lcShortcutMap) << "Possible shortcut key sequences:" << d->newEntries;
+    qDebug() << __FUNCTION__ << "Possible shortcut key sequences:" << d->newEntries;
 
     // Should never happen
     if (d->newEntries == d->currentSequences) {
@@ -456,8 +458,10 @@ QKeySequence::SequenceMatch QShortcutMap::find(QKeyEvent *e, int ignoredModifier
             oneKSResult = qMax(oneKSResult, tempRes);
             if (tempRes != QKeySequence::NoMatch && (*it).correctContext()) {
                 if (tempRes == QKeySequence::ExactMatch) {
-                    if ((*it).enabled)
+                    if ((*it).enabled) {
                         d->identicals.append(&*it);
+                        qDebug() << __FUNCTION__ << "identicals+=" << it->owner;
+                    }
                     else
                         identicalDisabledFound = true;
                 } else if (tempRes == QKeySequence::PartialMatch) {
@@ -628,6 +632,7 @@ QVector<const QShortcutEntry*> QShortcutMap::matches() const
 */
 void QShortcutMap::dispatchEvent(QKeyEvent *e)
 {
+    qDebug() << __FUNCTION__ << e;
     Q_D(QShortcutMap);
     if (!d->identicals.size())
         return;
@@ -647,9 +652,12 @@ void QShortcutMap::dispatchEvent(QKeyEvent *e)
             ++enabledShortcuts;
             if (lcShortcutMap().isDebugEnabled())
                 ambiguousShortcuts.append(current);
-            if (enabledShortcuts > d->ambigCount + 1)
+            if (enabledShortcuts > d->ambigCount + 1) {
+                qDebug() << __FUNCTION__ << "break loop";
                 break;
+            }
             next = current;
+            qDebug() << __FUNCTION__ << "Looping" << i << next->owner;
         }
         ++i;
     }
@@ -671,8 +679,10 @@ void QShortcutMap::dispatchEvent(QKeyEvent *e)
             << next->keyseq.toString() << "\", " << next->id << ", "
             << static_cast<bool>(enabledShortcuts>1) << ") to object(" << next->owner << ')';
     }
+    auto o = const_cast<QObject *>(next->owner);
+    qDebug() << __FUNCTION__ << o << next->keyseq;
     QShortcutEvent se(next->keyseq, next->id, enabledShortcuts>1);
-    QCoreApplication::sendEvent(const_cast<QObject *>(next->owner), &se);
+    QCoreApplication::sendEvent(o, &se);
 }
 
 /* \internal